/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.InvoiceItem;

import java.math.BigDecimal;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record8;
import org.jooq.Row8;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class InvoiceItemRecord extends UpdatableRecordImpl<InvoiceItemRecord> implements Record8<Integer, Integer, Integer, Integer, BigDecimal, String, BigDecimal, String> {

    private static final long serialVersionUID = 1457027620;

    /**
     * Setter for <code>INVOICE_ITEM.ID_ITEM</code>.
     */
    public void setIdItem(Integer value) {
        set(0, value);
    }

    /**
     * Getter for <code>INVOICE_ITEM.ID_ITEM</code>.
     */
    public Integer getIdItem() {
        return (Integer) get(0);
    }

    /**
     * Setter for <code>INVOICE_ITEM.ID_INVOICE</code>.
     */
    public void setIdInvoice(Integer value) {
        set(1, value);
    }

    /**
     * Getter for <code>INVOICE_ITEM.ID_INVOICE</code>.
     */
    public Integer getIdInvoice() {
        return (Integer) get(1);
    }

    /**
     * Setter for <code>INVOICE_ITEM.DESCRIPTION</code>.
     */
    public void setDescription(Integer value) {
        set(2, value);
    }

    /**
     * Getter for <code>INVOICE_ITEM.DESCRIPTION</code>.
     */
    public Integer getDescription() {
        return (Integer) get(2);
    }

    /**
     * Setter for <code>INVOICE_ITEM.INVOICE_POSITION</code>.
     */
    public void setInvoicePosition(Integer value) {
        set(3, value);
    }

    /**
     * Getter for <code>INVOICE_ITEM.INVOICE_POSITION</code>.
     */
    public Integer getInvoicePosition() {
        return (Integer) get(3);
    }

    /**
     * Setter for <code>INVOICE_ITEM.TOTAL</code>.
     */
    public void setTotal(BigDecimal value) {
        set(4, value);
    }

    /**
     * Getter for <code>INVOICE_ITEM.TOTAL</code>.
     */
    public BigDecimal getTotal() {
        return (BigDecimal) get(4);
    }

    /**
     * Setter for <code>INVOICE_ITEM.NOTE</code>.
     */
    public void setNote(String value) {
        set(5, value);
    }

    /**
     * Getter for <code>INVOICE_ITEM.NOTE</code>.
     */
    public String getNote() {
        return (String) get(5);
    }

    /**
     * Setter for <code>INVOICE_ITEM.TOTAL_ORIG_CURRENCY</code>.
     */
    public void setTotalOrigCurrency(BigDecimal value) {
        set(6, value);
    }

    /**
     * Getter for <code>INVOICE_ITEM.TOTAL_ORIG_CURRENCY</code>.
     */
    public BigDecimal getTotalOrigCurrency() {
        return (BigDecimal) get(6);
    }

    /**
     * Setter for <code>INVOICE_ITEM.ORIG_CURRENCY</code>.
     */
    public void setOrigCurrency(String value) {
        set(7, value);
    }

    /**
     * Getter for <code>INVOICE_ITEM.ORIG_CURRENCY</code>.
     */
    public String getOrigCurrency() {
        return (String) get(7);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record8 type implementation
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Row8<Integer, Integer, Integer, Integer, BigDecimal, String, BigDecimal, String> fieldsRow() {
        return (Row8) super.fieldsRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Row8<Integer, Integer, Integer, Integer, BigDecimal, String, BigDecimal, String> valuesRow() {
        return (Row8) super.valuesRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field1() {
        return InvoiceItem.INVOICE_ITEM.ID_ITEM;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field2() {
        return InvoiceItem.INVOICE_ITEM.ID_INVOICE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field3() {
        return InvoiceItem.INVOICE_ITEM.DESCRIPTION;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field4() {
        return InvoiceItem.INVOICE_ITEM.INVOICE_POSITION;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<BigDecimal> field5() {
        return InvoiceItem.INVOICE_ITEM.TOTAL;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field6() {
        return InvoiceItem.INVOICE_ITEM.NOTE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<BigDecimal> field7() {
        return InvoiceItem.INVOICE_ITEM.TOTAL_ORIG_CURRENCY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field8() {
        return InvoiceItem.INVOICE_ITEM.ORIG_CURRENCY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component1() {
        return getIdItem();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component2() {
        return getIdInvoice();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component3() {
        return getDescription();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component4() {
        return getInvoicePosition();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal component5() {
        return getTotal();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component6() {
        return getNote();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal component7() {
        return getTotalOrigCurrency();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component8() {
        return getOrigCurrency();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value1() {
        return getIdItem();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value2() {
        return getIdInvoice();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value3() {
        return getDescription();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value4() {
        return getInvoicePosition();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal value5() {
        return getTotal();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value6() {
        return getNote();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal value7() {
        return getTotalOrigCurrency();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value8() {
        return getOrigCurrency();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceItemRecord value1(Integer value) {
        setIdItem(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceItemRecord value2(Integer value) {
        setIdInvoice(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceItemRecord value3(Integer value) {
        setDescription(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceItemRecord value4(Integer value) {
        setInvoicePosition(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceItemRecord value5(BigDecimal value) {
        setTotal(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceItemRecord value6(String value) {
        setNote(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceItemRecord value7(BigDecimal value) {
        setTotalOrigCurrency(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceItemRecord value8(String value) {
        setOrigCurrency(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceItemRecord values(Integer value1, Integer value2, Integer value3, Integer value4, BigDecimal value5, String value6, BigDecimal value7, String value8) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        value5(value5);
        value6(value6);
        value7(value7);
        value8(value8);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached InvoiceItemRecord
     */
    public InvoiceItemRecord() {
        super(InvoiceItem.INVOICE_ITEM);
    }

    /**
     * Create a detached, initialised InvoiceItemRecord
     */
    public InvoiceItemRecord(Integer idItem, Integer idInvoice, Integer description, Integer invoicePosition, BigDecimal total, String note, BigDecimal totalOrigCurrency, String origCurrency) {
        super(InvoiceItem.INVOICE_ITEM);

        set(0, idItem);
        set(1, idInvoice);
        set(2, description);
        set(3, invoicePosition);
        set(4, total);
        set(5, note);
        set(6, totalOrigCurrency);
        set(7, origCurrency);
    }
}
